ClassFile.AttributesProcessingOption (Java SE 26 & JDK 26)
Description: declaration: module: java.base, package: java.lang.classfile, interface: ClassFile, enum: AttributesProcessingOption
Keywords: java.lang.classfile.ClassFile.AttributesProcessingOption class

# Enum Class ClassFile.AttributesProcessingOption

java.lang.Object
java.lang.Enum<ClassFile.AttributesProcessingOption>
java.lang.classfile.ClassFile.AttributesProcessingOption

All Implemented Interfaces:
  `Serializable, ClassFile.Option, Comparable<ClassFile.AttributesProcessingOption>, Constable`

Enclosing interface:
  `ClassFile`

public static enum ClassFile.AttributesProcessingOption extends Enum<ClassFile.AttributesProcessingOption> implements ClassFile.Option
The option describing whether to retain or discard attributes that cannot verify their correctness after a transformation. The default is `PASS_ALL_ATTRIBUTES` to retain all attributes as-is.

Many attributes only depend on data managed by the Class-File API, such as constant pool entries or labels into the `code` array. If they change, the Class-File API knows their updated values and can write a correct version by expanding the structures and recomputing the updated indexes, known as "explosion". However, some attributes, such as type annotations, depend on arbitrary data that may be modified during transformations but the Class-File API does not track, such as index to an entry in the interfaces of a `ClassFile` structure. As a result, the Class-File API cannot verify the correctness of such information.

Since:
  24
See Also:
  - `AttributeMapper.AttributeStability`

- ## Nested Class Summary

  ### Nested classes/interfaces declared in class Enum

  `Enum.EnumDesc<E>`
  Modifier and Type
  Class
  Description
  `static final class`
  `Enum.EnumDesc<E extends Enum<E>>`
  A nominal descriptor for an `enum` constant.

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `DROP_UNKNOWN_ATTRIBUTES`
  Drop attributes with `AttributeMapper.AttributeStability.UNKNOWN` data dependency during transformation.
  `DROP_UNSTABLE_ATTRIBUTES`
  Drop attributes with `AttributeMapper.AttributeStability.UNSTABLE` or higher data dependency during transformation.
  `PASS_ALL_ATTRIBUTES`
  Retain all original attributes during transformation.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static ClassFile.AttributesProcessingOption`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static ClassFile.AttributesProcessingOption[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.

  ### Methods declared in class Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`
  Modifier and Type
  Method
  Description
  `protected final Object`
  `clone()`
  Throws CloneNotSupportedException.
  `final int`
  `compareTo(ClassFile.AttributesProcessingOption o)`
  Compares this enum with the specified object for order.
  `final Optional<Enum.EnumDesc<ClassFile.AttributesProcessingOption>>`
  `describeConstable()`
  Returns an enum descriptor `EnumDesc` for this instance, if one can be constructed, or an empty `Optional` if one cannot be.
  `final boolean`
  `equals(Object other)`
  Returns true if the specified object is equal to this enum constant.
  `protected final void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization has been deprecated for removal.
  `final Class<ClassFile.AttributesProcessingOption>`
  `getDeclaringClass()`
  Returns the Class object corresponding to this enum constant's enum type.
  `final int`
  `hashCode()`
  Returns a hash code for this enum constant.
  `final String`
  `name()`
  Returns the name of this enum constant, exactly as declared in its enum declaration.
  `final int`
  `ordinal()`
  Returns the ordinal of this enumeration constant (its position in its enum declaration, where the initial constant is assigned an ordinal of zero).
  `String`
  `toString()`
  Returns the name of this enum constant, as contained in the declaration.
  `static <T extends Enum<T>>
  T`
  `valueOf(Class<T> enumClass, String name)`
  Returns the enum constant of the specified enum class with the specified name.

  ### Methods declared in class Object

  `getClass, notify, notifyAll, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Enum Constant Details

  - ### PASS_ALL_ATTRIBUTES

    public static final ClassFile.AttributesProcessingOption PASS_ALL_ATTRIBUTES
    Retain all original attributes during transformation.

  - ### DROP_UNKNOWN_ATTRIBUTES

    public static final ClassFile.AttributesProcessingOption DROP_UNKNOWN_ATTRIBUTES
    Drop attributes with `AttributeMapper.AttributeStability.UNKNOWN` data dependency during transformation.

  - ### DROP_UNSTABLE_ATTRIBUTES

    public static final ClassFile.AttributesProcessingOption DROP_UNSTABLE_ATTRIBUTES
    Drop attributes with `AttributeMapper.AttributeStability.UNSTABLE` or higher data dependency during transformation.

- ## Method Details

  - ### values

    public static ClassFile.AttributesProcessingOption[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static ClassFile.AttributesProcessingOption valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null